
--dim cleanup!!!



local self = {}


self.bosskill = {}




local garbage

local SkillScore_TTLine
local SkillScore_TTTextLEFT
local SkillScore_TTTextRIGHT
local SkillScore_TTTextDetailsLEFT, SkillScore_TTTextDetailsRIGHT = '', ''
local TT_LINECOUNTER_LEFT, TT_LINECOUNTER_RIGHT
local SkillScore_TooltipActive


local function SkillScore_HexColor(raidzone, NORMvalue)
	
	--don't return tables (garbage) ???
	if NORMvalue > raidzone.purple then
		return '|cCCA335EE'
	elseif NORMvalue > raidzone.blue then
		return '|cCC0070DD'
	else
		return '|cCC1EFF00'
	end
	
end

local function SkillScore_Scan()

	ClearAchievementComparisonUnit()
	
	SkillScore_Frame:RegisterEvent('INSPECT_ACHIEVEMENT_READY')
	SetAchievementComparisonUnit(self.unit)
	
end

local function SkillScore_Output()
	
	SkillScoreData_RaidZones[1].NORMskillscore = floor(SkillScoreData_RaidZones[1].skillscore * 1000/SkillScoreData_RaidZones[1].totalvalue)
	SkillScoreData_RaidZones[2].NORMskillscore = floor(SkillScoreData_RaidZones[2].skillscore * 1000/SkillScoreData_RaidZones[2].totalvalue)

	SkillScore_TTTextLEFT = SkillScore_colors.std..'\nSkillScore ICC10 / 25'
	SkillScore_TTTextRIGHT = '\n'..
		SkillScore_HexColor(SkillScoreData_RaidZones[1], SkillScoreData_RaidZones[1].NORMskillscore)..SkillScoreData_RaidZones[1].NORMskillscore..
		SkillScore_colors.std..' / '..
		SkillScore_HexColor(SkillScoreData_RaidZones[2], SkillScoreData_RaidZones[2].NORMskillscore)..SkillScoreData_RaidZones[2].NORMskillscore

	SkillScore_TTTextDetailsLEFT = SkillScore_colors.std..'\nSkillScore ICC10: '..
		SkillScore_HexColor(SkillScoreData_RaidZones[1], SkillScoreData_RaidZones[1].NORMskillscore)..SkillScoreData_RaidZones[1].NORMskillscore..
		SkillScore_TTTextDetailsLEFT
		
	SkillScore_TTTextDetailsRIGHT = SkillScore_colors.std..'\nSkillScore ICC25: '..
		SkillScore_HexColor(SkillScoreData_RaidZones[2], SkillScoreData_RaidZones[2].NORMskillscore)..SkillScoreData_RaidZones[2].NORMskillscore..
		SkillScore_TTTextDetailsRIGHT
	
	if TT_LINECOUNTER_LEFT ~= TT_LINECOUNTER_RIGHT then		--adjust left/right tooltip lines for detailed tooltip
			
		for i=0, abs(TT_LINECOUNTER_LEFT-TT_LINECOUNTER_RIGHT) do
			if TT_LINECOUNTER_LEFT > TT_LINECOUNTER_RIGHT then
				SkillScore_TTTextDetailsRIGHT = SkillScore_TTTextDetailsRIGHT..'\n'
			else
				SkillScore_TTTextDetailsLEFT = SkillScore_TTTextDetailsLEFT..'\n'
			end
		end
	end
		
	GameTooltip:AddDoubleLine(SkillScore_TTTextLEFT, SkillScore_TTTextRIGHT)
	GameTooltip:Show() --update the GameTooltip
	SkillScore_TooltipActive = 'true'
	
	
	for i=1,GameTooltip:NumLines() do	--find SkillScore Line in Tooltip
		local mytext = getglobal("GameTooltipTextLeft" .. i)
		--if mytext:GetText() and mytext:GetText():sub(1,11) == '\nSkillScore' then SkillScore_TTLine = i end
		if mytext:GetText() and strfind(mytext:GetText(), 'SkillScore') then SkillScore_TTLine = i end
		
	end
	
	if SkillScore_TTLine and self.modkey == 1 then 
		getglobal("GameTooltipTextLeft" .. SkillScore_TTLine):SetText(SkillScore_TTTextDetailsLEFT)
		getglobal("GameTooltipTextRight" .. SkillScore_TTLine):SetText(SkillScore_TTTextDetailsRIGHT) 
		GameTooltip:Show()
	end
		
end

local function SkillScore_DetailsToggle()

	if SkillScore_TooltipActive == 'false' or (InCombatLockdown() and InCombatLockdown() == 1) then return end
	
	if SkillScore_TTLine and self.modkey == 1 then
		getglobal("GameTooltipTextLeft" .. SkillScore_TTLine):SetText(SkillScore_TTTextDetailsLEFT)
		getglobal("GameTooltipTextRight" .. SkillScore_TTLine):SetText(SkillScore_TTTextDetailsRIGHT) 
		GameTooltip:Show()
	elseif SkillScore_TTLine then
		getglobal("GameTooltipTextLeft" .. SkillScore_TTLine):SetText(SkillScore_TTTextLEFT)
		getglobal("GameTooltipTextRight" .. SkillScore_TTLine):SetText(SkillScore_TTTextRIGHT) 
		GameTooltip:Show()
	end	

end

local function SkillScore_Calc()

	if not GetComparisonAchievementPoints() or GetComparisonAchievementPoints() == 0 then return end	--check if valid achievement dataz received from server

	SkillScore_TTTextDetailsLEFT = '\n'
	SkillScore_TTTextDetailsRIGHT = '\n'
	TT_LINECOUNTER_LEFT, TT_LINECOUNTER_RIGHT = 0, 0
		
	
	
	for RAID_NUM = 1, #SkillScoreData_RaidZones do
		
		if SkillScoreData_RaidZones[RAID_NUM].minlvl > UnitLevel(self.unit) then return end
				
		SkillScoreData_RaidZones[RAID_NUM].skillscore = 0
		SkillScoreData_RaidZones[RAID_NUM].totalvalue = 0
		
		self.value = 0
		--garbage = collectgarbage("count")		
		for j = 1, #SkillScoreData_RaidZones[RAID_NUM].aids do
			
			if SkillScoreData_RaidZones[RAID_NUM].aids[j].atype == 'bosskill' then
			
				self.bosskill.value = 0
				
				if GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].hc) and (tonumber(GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].hc)) or 0) > 0 then
					self.bosskill.value = tonumber(GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].hc)) or 0
					self.bosskill.color = '|cCCA335EE' --purple
					self.value = SkillScoreData_RaidZones[RAID_NUM].aids[j].hcvalue + SkillScoreData_RaidZones[RAID_NUM].aids[j].nhvalue
					self.bosskill.name = select(2, GetAchievementInfo(SkillScoreData_RaidZones[RAID_NUM].aids[j].hc))
				elseif GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].nh) and (tonumber(GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].nh)) or 0) > 0 then
					self.bosskill.value = tonumber(GetComparisonStatistic(SkillScoreData_RaidZones[RAID_NUM].aids[j].nh)) or 0
					self.bosskill.color = '|cCC1EFF00' --green
					self.value = SkillScoreData_RaidZones[RAID_NUM].aids[j].nhvalue
					self.bosskill.name = select(2, GetAchievementInfo(SkillScoreData_RaidZones[RAID_NUM].aids[j].nh))
				end
				
				if self.bosskill.value > 0 then 
									
					SkillScoreData_RaidZones[RAID_NUM].skillscore = SkillScoreData_RaidZones[RAID_NUM].skillscore + self.value
--needs memory improvements
					if RAID_NUM==1 then
						SkillScore_TTTextDetailsLEFT = SkillScore_TTTextDetailsLEFT..'\n'..self.bosskill.color..self.bosskill.value..' '..self.bosskill.name
						TT_LINECOUNTER_LEFT = TT_LINECOUNTER_LEFT + 1
					elseif RAID_NUM==2 then
						SkillScore_TTTextDetailsRIGHT = SkillScore_TTTextDetailsRIGHT..'\n'..self.bosskill.color..self.bosskill.value..' '..self.bosskill.name
						TT_LINECOUNTER_RIGHT = TT_LINECOUNTER_RIGHT + 1
					end
					
				end
			
			elseif SkillScoreData_RaidZones[RAID_NUM].aids[j].atype == 'achievement' then
			
				local Name = select(2, GetAchievementInfo(SkillScoreData_RaidZones[RAID_NUM].aids[j].aid))
			
				if GetAchievementComparisonInfo(SkillScoreData_RaidZones[RAID_NUM].aids[j].aid) then
			
					SkillScoreData_RaidZones[RAID_NUM].skillscore = SkillScoreData_RaidZones[RAID_NUM].skillscore + SkillScoreData_RaidZones[RAID_NUM].aids[j].avalue
--needs memory improvements			
					if  RAID_NUM==1 then
						SkillScore_TTTextDetailsLEFT = SkillScore_TTTextDetailsLEFT..'\n'..SkillScoreData_RaidZones[RAID_NUM].aids[j].color..Name
						TT_LINECOUNTER_LEFT = TT_LINECOUNTER_LEFT + 1
					elseif RAID_NUM==2 then
						SkillScore_TTTextDetailsRIGHT = SkillScore_TTTextDetailsRIGHT..'\n'..SkillScoreData_RaidZones[RAID_NUM].aids[j].color..Name
						TT_LINECOUNTER_RIGHT = TT_LINECOUNTER_RIGHT + 1
					end
				
				end
				
			end
			
		SkillScoreData_RaidZones[RAID_NUM].totalvalue = SkillScoreData_RaidZones[RAID_NUM].totalvalue + (SkillScoreData_RaidZones[RAID_NUM].aids[j].avalue or (SkillScoreData_RaidZones[RAID_NUM].aids[j].hcvalue + SkillScoreData_RaidZones[RAID_NUM].aids[j].nhvalue))
			
		end
		--garbage = collectgarbage("count") - garbage; print(format('%.3fkB',garbage)); garbage = collectgarbage("count")
	end
			
	SkillScore_Output()
	
	if _G.GearScore then
        _G.GearScore:RegisterEvent('INSPECT_ACHIEVEMENT_READY')
    end
	
	SkillScore_Frame:UnregisterEvent('INSPECT_ACHIEVEMENT_READY')
	ClearAchievementComparisonUnit()
	
	
	
end


local function SkillScore_UnitTooltip()

	if InCombatLockdown() and InCombatLockdown() == 1 then return end
	if AchievementFrame and AchievementFrame:IsShown() then return end
	
	self.unit = select(2, GameTooltip:GetUnit())
	if not UnitIsPlayer(self.unit) then return end

	if _G.GearScore then
		_G.GearScore:UnregisterEvent('INSPECT_ACHIEVEMENT_READY')
    end
		
	SkillScore_Scan()

end

local function SkillScore_OnTooltipCleared()

	if SkillScore_Frame:IsEventRegistered('INSPECT_ACHIEVEMENT_READY') and SkillScore_Frame:IsEventRegistered('INSPECT_ACHIEVEMENT_READY') == 1 then
		SkillScore_Frame:UnregisterEvent('INSPECT_ACHIEVEMENT_READY')
	end
	
	SkillScore_TooltipActive = 'false'
	
	
	
end


local function SkillScore_Blizzard_AchievementUI_OnShow()

	if not AchievementFrameComparison:IsEventRegistered('INSPECT_ACHIEVEMENT_READY') then AchievementFrameComparison:RegisterEvent('INSPECT_ACHIEVEMENT_READY') end

end

local function SkillScore_Blizzard_AchievementUI_OnHide()

	if AchievementFrameComparison:IsEventRegistered('INSPECT_ACHIEVEMENT_READY') then AchievementFrameComparison:UnregisterEvent('INSPECT_ACHIEVEMENT_READY') end

end


function SkillScore_OnLoad()
	
	GameTooltip:HookScript('OnTooltipSetUnit', SkillScore_UnitTooltip)
	GameTooltip:HookScript('OnTooltipCleared', SkillScore_OnTooltipCleared)
	SkillScore_Frame:RegisterEvent('MODIFIER_STATE_CHANGED')
	SkillScore_Frame:RegisterEvent('ACHIEVEMENT_EARNED')
	SkillScore_Frame:RegisterEvent('ADDON_LOADED')
end

function SkillScore_OnEvent(frame, event, arg1, arg2)
	--InCombatLock here needs testing
	
	if (event == "ADDON_LOADED" and arg1 == "Blizzard_AchievementUI") then
		SkillScore_Frame:UnregisterEvent("ADDON_LOADED")
		if AchievementFrame then
			AchievementFrame:HookScript('OnShow', SkillScore_Blizzard_AchievementUI_OnShow)
			AchievementFrame:HookScript('OnHide', SkillScore_Blizzard_AchievementUI_OnHide)
		end
	
	elseif (event == "ADDON_LOADED" and arg1 == "SkillScore") then
	
		skillscoreDB = skillscoreDB or { }
		
		for k, v in pairs(SkillScoreDefaults) do
		
			if(type(skillscoreDB[k]) == 'nil') then
				skillscoreDB[k] = v
			end
		end
		
		UIDropDownMenu_SetSelectedID(SkillScoreDropDownMenu, skillscoreDB['modkey'][2] or 1)
		
		
	end
		
	
	
	if event == 'INSPECT_ACHIEVEMENT_READY' then
		
		SkillScore_Calc()
		
		
	--elseif (event == 'MODIFIER_STATE_CHANGED') and (arg1 == 'LCTRL' or arg1 == 'RCTRL') then
	elseif (event == 'MODIFIER_STATE_CHANGED') and (arg1 == skillscoreDB['modkey'][1]) then
		self.modkey = arg2
		SkillScore_DetailsToggle()
	
	elseif (event == 'ACHIEVEMENT_EARNED') then
		--error 568 fix after earning an Achievement
		if AchievementFrame and not AchievementFrame:IsVisible() and AchievementFrameComparison and AchievementFrameComparison:IsEventRegistered('INSPECT_ACHIEVEMENT_READY') then 
			AchievementFrameComparison:UnregisterEvent('INSPECT_ACHIEVEMENT_READY')
		end
	
	end
end




local function SlashCommand(cmd)
	
	if cmd == 'scan' then
		print('SS scan target')
		SkillScore_Scan()
	end
	
	InterfaceOptionsFrame_OpenToCategory('SkillScore')
	
end


SLASH_SKILLSCORE1 = "/skillscore";	
SlashCmdList["SKILLSCORE"] = SlashCommand;

-- ####################################################################################
