
SkillScoreConfig = { };

SkillScoreDefaults = {
	modkey = {
		'LCTRL',
		1,
		}

}



local frame = CreateFrame("Frame", nil, InterfaceOptionsFramePanelContainer);
SkillScoreConfig.frame = frame;

local title = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
	title:SetPoint("TOPLEFT", 16, -16)
	title:SetText('SkillScore')

local subtitle = frame:CreateFontString(nil, "ARTWORK", "GameFontHighlightSmall")
	--subtitle:SetHeight(32)
	subtitle:SetPoint("TOPLEFT", title, "BOTTOMLEFT", 0, -8)
	subtitle:SetPoint("RIGHT", parent, -32, 0)
	subtitle:SetNonSpaceWrap(true)
	subtitle:SetJustifyH("LEFT")
	subtitle:SetJustifyV("TOP")
	subtitle:SetText('')
	
local modkey = frame:CreateFontString(nil, "ARTWORK", "GameFontNormalSmall")
	modkey:SetPoint("TOPLEFT", subtitle, "BOTTOMLEFT", 0, -20)
	modkey:SetText(SkillScoreLocalization['DETAILSMODIFIER'])

	
if not SkillScoreDropDownMenu then
	CreateFrame("Frame", "SkillScoreDropDownMenu", SkillScoreConfig.frame, "UIDropDownMenuTemplate")
	
 end

 SkillScoreDropDownMenu:ClearAllPoints()
 SkillScoreDropDownMenu:SetPoint("TOPLEFT", modkey, 'BOTTOMLEFT', 0, -5)
 SkillScoreDropDownMenu:Show()

local items = {
	SkillScoreLocalization['LCTRL'],
	SkillScoreLocalization['RCTRL'],
	SkillScoreLocalization['LALT'],
	SkillScoreLocalization['RALT'],
 }

 local function OnClick(self)
   UIDropDownMenu_SetSelectedID(SkillScoreDropDownMenu, self:GetID())
   
	if self:GetID() == 1 then
		skillscoreDB["modkey"] = {
			'LCTRL',
			1,
		}
	elseif self:GetID() == 	2 then
		skillscoreDB["modkey"] = {
			'RCTRL',
			2,
		}
	elseif self:GetID() == 	3 then
		skillscoreDB["modkey"] = {
			'LALT',
			3,
		}
	elseif self:GetID() == 	4 then
		skillscoreDB["modkey"] = {
			'RALT',
			4,
		}
	end
   
 end

 local function initialize(self, level)
   local info = UIDropDownMenu_CreateInfo()
   for k,v in pairs(items) do
	 info = UIDropDownMenu_CreateInfo()
	 info.text = v
	 info.value = v
	 info.func = OnClick
	 UIDropDownMenu_AddButton(info, level)
   end
   
   
   
 end


 UIDropDownMenu_Initialize(SkillScoreDropDownMenu, initialize)
 UIDropDownMenu_SetWidth(SkillScoreDropDownMenu, 100);
 UIDropDownMenu_SetButtonWidth(SkillScoreDropDownMenu, 124)
 --UIDropDownMenu_SetSelectedID(SkillScoreDropDownMenu, 1)
 UIDropDownMenu_JustifyText(SkillScoreDropDownMenu, "LEFT")

 
function SkillScoreConfig_OnLoad ()
	local panel = SkillScoreConfig.frame;
	panel.name = "SkillScore";
	InterfaceOptions_AddCategory(panel);

 	--

	
end


