
SkillScore_colors = {
	std	= '|cCCFFD200',
	green = '|cCC1EFF00',
	blue = '|cCC0070DD',
	purple = '|cCCA335EE',
	}


SkillScoreData_ICC10 = {
	
	--header
	raidzone = 'ICC10',
	blue = 200,
	purple = 600,
	minlvl = 80,
	
	--achievement ids
	aids = {
	--4531,	--Storming the Citadel(10 Player)
	--4628,	--Heroic: Storming the Citadel (10 player)
		{atype = 'bosskill', nh = 4639,	hc = 4640, nhvalue = 0.25, hcvalue = 1},		--Lord MG
		{atype = 'bosskill', nh = 4643,	hc = 4654, nhvalue = 0.25, hcvalue = 1},		--Lady DW
		{atype = 'bosskill', nh = 4644,	hc = 4659, nhvalue = 0.25, hcvalue = 1}, 		--Gunship
		{atype = 'bosskill', nh = 4645, hc = 4662, nhvalue = 0.25, hcvalue = 1},		--Deathbringer
	--4528,	--The Plagueworks(10 Player)
	--4629,	--Heroic: The Plagueworks (10 player)
		{atype = 'bosskill', nh = 4646, hc = 4665, nhvalue = 0.33, hcvalue = 1.33},		--Festergut
		{atype = 'bosskill', nh = 4647, hc = 4668, nhvalue = 0.33, hcvalue = 1.33},		--Rotface
		{atype = 'bosskill', nh = 4650, hc = 4677, nhvalue = 0.33, hcvalue = 1.33},		--Prof.P.
	--4529,	--The Crimson Hall(10 Player)
	--4630,	--Heroic: The Crimson Hall (10 player)
		{atype = 'bosskill', nh = 4648, hc = 4671, nhvalue = 0.5, hcvalue = 2},			--BPC
		{atype = 'bosskill', nh = 4651, hc = 4680, nhvalue = 0.5, hcvalue = 2},			--BQL
	--4527,	--The Frostwing Halls (10 player)	
	--4631,	--Heroic: The Frostwing Halls (10 player)
		{atype = 'bosskill', nh = 4649, hc = 4674, nhvalue = 0.5, hcvalue = 2},			--Dreamwalker
		{atype = 'bosskill', nh = 4652, hc = 4684, nhvalue = 0.5, hcvalue = 2},			--Sindragosa
	--4532,	--Fall of the Lich King (10 player)
	--4636,	--Heroic: Fall of the Lich King (10 player)
		{atype = 'bosskill', nh = 4653, hc = 4686, nhvalue = 1, hcvalue = 4},			--Lich King
			
	--Achievements
		{atype = 'achievement', aid = 4534,	avalue = 1, color = SkillScore_colors.blue},	--Boned(10 Player)
		{atype = 'achievement', aid = 4537,	avalue = 1, color = SkillScore_colors.blue},	--I've Gone and Made a Mess (10 player)
		{atype = 'achievement', aid = 4535,	avalue = 1, color = SkillScore_colors.blue},	--Full House (10 player)
		{atype = 'achievement', aid = 4536,	avalue = 1, color = SkillScore_colors.blue},	--I'm on a Boat (10 player)
		{atype = 'achievement', aid = 4538,	avalue = 1, color = SkillScore_colors.blue},	--Dances with Oozes (10 player)
		{atype = 'achievement', aid = 4577,	avalue = 1, color = SkillScore_colors.blue},	--Flu Shot Shortage (10 player)
		{atype = 'achievement', aid = 4578,	avalue = 1, color = SkillScore_colors.blue},	--Nausea, Heartburn, Indigestion... (10 player)
		{atype = 'achievement', aid = 4582,	avalue = 1, color = SkillScore_colors.blue},	--The Orb Whisperer (10 player)
		{atype = 'achievement', aid = 4539,	avalue = 1, color = SkillScore_colors.blue},	--Once Bitten, Twice Shy (10 player)
		{atype = 'achievement', aid = 4579,	avalue = 1, color = SkillScore_colors.blue},	--Portal Jockey (10 player)
		{atype = 'achievement', aid = 4580,	avalue = 1, color = SkillScore_colors.blue},	--All You Can Eat (10 player)
		{atype = 'achievement', aid = 4601,	avalue = 1, color = SkillScore_colors.blue},	--Been Waiting a Long Time for This (10 player)
		{atype = 'achievement', aid = 4581,	avalue = 1, color = SkillScore_colors.blue},	--Neck-Deep in Vile (10 player)
		
		--4530,	--The Frozen Throne (10 player)							
		--[[{aid = 4583,	--Bane of the Fallen King
		avalue = 2, color = SkillScore_colors.blue},]]
	},
}

SkillScoreData_ICC25 = {

	
	--header
	raidzone = 'ICC25',
	blue = 200,
	purple = 600,
	minlvl = 80,
	
	--achievement ids
	aids = {
		--4604,	--Storming the Citadel (25 player)
		--4632,	--Heroic: Storming the Citadel (25 player)
		{atype = 'bosskill', nh = 4641, hc = 4642, nhvalue = 0.25, hcvalue = 1},		--Lord MG
		{atype = 'bosskill', nh = 4655, hc = 4656, nhvalue = 0.25, hcvalue = 1},		--Lady D.
		{atype = 'bosskill', nh = 4660,	hc = 4661, nhvalue = 0.25, hcvalue = 1},		--Gunship
		{atype = 'bosskill', nh = 4663,	hc = 4664, nhvalue = 0.25, hcvalue = 1},		--Deathbringer
		--4605,	--The Plagueworks (25 player)
		--4633,	--Heroic: The Plagueworks (25 player)
		{atype = 'bosskill', nh = 4666, hc = 4667, nhvalue = 0.33, hcvalue = 1.33},		--Festergut
		{atype = 'bosskill', nh = 4669, hc = 4670, nhvalue = 0.33, hcvalue = 1.33},		--Rotface
		{atype = 'bosskill', nh = 4678, hc = 4679, nhvalue = 0.33, hcvalue = 1.33},		--Prof.P.
		--4606,	--The Crimson Hall (25 player)
		--4634,	--Heroic: The Crimson Hall (25 player)
		{atype = 'bosskill', nh = 4672, hc = 4673, nhvalue = 0.5, hcvalue = 2},			--BPC
		{atype = 'bosskill', nh = 4681, hc = 4682, nhvalue = 0.5, hcvalue = 2},			--BQL	
		--4607,	--The Frostwing Halls (25 player)
		--4635,	--Heroic: The Frostwing Halls (25 player)
		{atype = 'bosskill', nh = 4675, hc = 4676, nhvalue = 0.5, hcvalue = 2},			--Dreamwalker
		{atype = 'bosskill', nh = 4683, hc = 4685, nhvalue = 0.5, hcvalue = 2},			--Sindragosa
		--4608,	--Fall of the Lich King (25 player)		BOSS ACH4687
		--4637,	--Heroic: Fall of the Lich King (25 player) BOSS ACH 4688
		{atype = 'bosskill', nh = 4687, hc = 4688, nhvalue = 1, hcvalue = 4},			-- Lich King
		
		{atype = 'achievement', aid = 4610,	avalue = 1, color = SkillScore_colors.blue},	--Boned (25 player)
		{atype = 'achievement', aid = 4613,	avalue = 1, color = SkillScore_colors.blue},	--I've Gone and Made a Mess (25 player)
		{atype = 'achievement', aid = 4611,	avalue = 1, color = SkillScore_colors.blue},	--Full House (25 player)
		{atype = 'achievement', aid = 4612,	avalue = 1, color = SkillScore_colors.blue},	--I'm on a Boat (25 player)
		{atype = 'achievement', aid = 4614,	avalue = 1, color = SkillScore_colors.blue},	--Dances with Oozes (25 player)
		{atype = 'achievement', aid = 4615,	avalue = 1, color = SkillScore_colors.blue},	--Flu Shot Shortage (25 player)
		{atype = 'achievement', aid = 4616,	avalue = 1, color = SkillScore_colors.blue},	--Nausea, Heartburn, Indigestion... (25 player)
		{atype = 'achievement', aid = 4617,	avalue = 1, color = SkillScore_colors.blue},	--The Orb Whisperer (25 player)
		{atype = 'achievement', aid = 4618,	avalue = 1, color = SkillScore_colors.blue},	--Once Bitten, Twice Shy (25 player)	
		{atype = 'achievement', aid = 4619,	avalue = 1, color = SkillScore_colors.blue},	--Portal Jockey (25 player)
		{atype = 'achievement', aid = 4620,	avalue = 1, color = SkillScore_colors.blue},	--All You Can Eat (25 player)
		{atype = 'achievement', aid = 4621,	avalue = 1, color = SkillScore_colors.blue},	--Been Waiting a Long Time for This (25 player)
		{atype = 'achievement', aid = 4622,	avalue = 1, color = SkillScore_colors.blue},	--Neck-Deep in Vile (25 player)
		--4584,	--The Light of Dawn
		--4597,	--The Frozen Throne (25 player)
	
	}
}

SkillScoreData_CC10 = {

	--header
	raidzone = 'CC10',
	blue = 200,
	purple = 600,

}


SkillScoreData_RaidZones = {
	SkillScoreData_ICC10,
	SkillScoreData_ICC25,
	--SkillScoreData_CC10,
}